<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2005 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * $Source: /home/cvs/pragmamx/stable/includes/mx_userfunctions.php,v $
 * $Revision: 1.12.4.1 $
 * $Author: tora60 $
 * $Date: 2006/01/17 21:56:57 $
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");
// / Tabelle fr private Nachrichten
$GLOBALS['tblprivatemessage'] = $GLOBALS['prefix'] . "_priv_msgs";
// Definieren der gesperrten Namen
define("vkpBadUserNames", "^((anonymous)|(unbekannt)|(" . $GLOBALS['anonymous'] . ")" . mxGetCensorListUsers() . ")$");

if (@file_exists("includes/mx_userfunctions_options.php")) {
    include_once("includes/mx_userfunctions_options.php");
} 
// ################################################
// Auslesen der gesperrten Namen
function mxGetCensorListUsers()
{
    global $prefix, $CensorListUsers;
    $CensorListUsers = array(); // das alte array() aus der config.php berschreiben
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query("SELECT ban_val FROM " . $prefix . "_user_ban WHERE ban_type='ban_name'");
    while (list($ban_name) = sql_fetch_row($result)) {
        $CensorListUsers[] = $ban_name;
    } 
    // / die unerlaubten Benutzernamen und die zensierten Wrter als unerlaubte Benutzernamen definieren
    $CensorListUsers = array_merge($CensorListUsers, $GLOBALS['CensorList']);
    if (!empty($CensorListUsers)) {
        return '|(' . implode(')|(', $CensorListUsers) . ')';
    } 
    return '';
} 
// ################################################
function userNavigation($act = "")
{
    $link['login'] = "<a href=\"modules.php?name=Your_Account\">" . _USERLOGIN . "</a>";
    $link['lost'] = "<a href=\"modules.php?name=Your_Account&amp;op=pass_lost\">" . _PASSWORDLOST . "</a>";
    if (mxModuleAllowed("User_Registration")) $link['reg'] = "<a href=\"modules.php?name=User_Registration\">" . _REGNEWUSER . "</a>";

    if ($act) unset($link[$act]);

    if (!empty($link)) {
        $link = implode(" | ", $link);
        OpenTable();
        echo "<center><font class=\"content\">[  " . $link . "  ]</font></center>\n";
        CloseTable();
        echo "<br>";
    } 
} 
// ################################################
function userCheck($pvs)
{
    global $user_prefix, $prefix; 
    // $pvs['uname']      = str_replace(" ","_",$pvs['uname']);
    $pvs['uname'] = trim(substr(preg_replace('~[\t\n\r\x0B\0\xA0]+~', ' ', $pvs['uname']), 0, 25)); // von SMF:
    $pvs['email'] = str_replace(" ", "", $pvs['email']);
    $pvs['user_sexus'] = (empty($pvs['user_sexus'])) ? 0 : (int)$pvs['user_sexus'];
    $pvs['user_avatar'] = (empty($pvs['user_avatar'])) ? "" : strip_tags($pvs['user_avatar']);
    $pvs['user_avatar'] = ($pvs['user_avatar'] == "blank.gif") ? "" : strip_tags($pvs['user_avatar']);
    $pvs['newsletter'] = (empty($pvs['newsletter'])) ? 0 : 1;
    $pvs['url'] = (empty($pvs['url'])) ? "" : mxCutHTTP($pvs['url']); 
    // $user_viewemail = (empty($user_viewemail)) ? 0 : 1;
    // Geburtstag pruefen, ggf. aendern
    $checkdate1 = sprintf("%04d%02d%02d", $pvs['bday_year'], $pvs['bday_month'], $pvs['bday_day']);
    $checkdate2 = sprintf("%04d%02d%02d", date('Y'), date('m'), date('d'));
    $isdate = checkdate(intval($pvs['bday_month']), intval($pvs['bday_day']), intval($pvs['bday_year']));
    $isdate = ($checkdate1 > $checkdate2) ? false : $isdate;
    $pvs['bday'] = ($isdate) ? sprintf("%04d-%02d-%02d", $pvs['bday_year'], $pvs['bday_month'], $pvs['bday_day']) : "";

    /**
     * START Mindestalter / Geburtsdatum Plichtfeld - 2005-05-10  (RtR)
     */
    if ((empty($pvs['bday'])) && (isset($GLOBALS['yaproofdate']) && $GLOBALS['yaproofdate'] != 0)) {
        return _ERROREMPYBDATE;
    } 
    if (isset($GLOBALS['yaproofdate']) && $GLOBALS['yaproofdate'] != 0) {
        $checkdatum1 = sprintf("%02d%02d", $pvs['bday_month'], $pvs['bday_day']);
        $checkdatum2 = sprintf("%02d%02d", date('m'), date('d'));
        $diff = (int)($checkdatum1 > $checkdatum2);
        $useryear = date('Y') - $pvs['bday_year'] - $diff;
        if ($useryear < $GLOBALS['yaproofdate']) {
            $error_tooyoung = "" . _ERROR2YOUNG1 . "&nbsp;";
            $error_tooyoung .= "<strong>{$GLOBALS['yaproofdate']}</strong>&nbsp;";
            $error_tooyoung .= "" . _ERROR2YOUNG2 . "";
            return $error_tooyoung;
        } 
    } 
    /**
     * ENDE Mindestalter / Geburtsdatum Plichtfeld
     */

    /**
     * START gesperrte eMail prfen - 2005-08-06  (RtR)
     */
    $mail_banned = sql_query("SELECT ban_val FROM " . $prefix . "_user_ban WHERE ban_type='ban_mail'");
    while (list($ban_mail) = sql_fetch_row($mail_banned)) {
        if (eregi("$ban_mail", $pvs['email'])) {
            $mail_is_banned = 1;
        } 
    } 
    @sql_query("OPTIMIZE TABLE " . $prefix . "_mxliky01_user_ban");
    if (!empty($mail_is_banned)) {
        return _BLOCKEDMAIL;
    } 
    /**
     * ENDE gesperrte eMail prfen
     */

    /**
     * START Benutzer muessen den AGB zustimmen - 2005-18-05  (RtR)
     */
    $pvs['readrules'] = (empty($pvs['readrules'])) ? 0 : (int)$pvs['readrules'];
    if ($pvs['op'] == "confirm" && !empty($GLOBALS['agb_content']) && $pvs['readrules'] != 1) {
        return _NOTAGREE;
    } 
    /**
     * ENDE Benutzer muessen den AGB zustimmen
     */
    // mxDebugFuncvars($pvs); exit;
    if (empty($pvs['email'])) {
        return _ERRORNOEMAIL;
    } 
    if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$", $pvs['email'])) {
        return _ERRORINVEMAIL;
    } 
    if ($pvs['op'] == "confirm" || $pvs['op'] == "finish") {
        if (strlen($pvs['uname']) > 25) {
            return _NICK2LONG;
        } 
        // if (empty($pvs['uname']) || ereg("[^a-zA-Z0-9_-]",$pvs['uname']) || is_numeric($pvs['uname'])){  /// damit keine leerzeichen erlaubt
        if (empty($pvs['uname']) || ereg("[^a-zA-Z0-9 _-]", $pvs['uname']) || is_numeric($pvs['uname'])) {
            return _ERRORINVNICK;
        } 
        if (eregi($pvs['uname'], vkpBadUserNames)) {
            return _NAMERESERVED;
        } 
        // if (strrpos($pvs['uname'],' ') > 0) {
        // return _NICKNOSPACES;
        // }
        if (sql_num_rows(sql_query("select email from ${user_prefix}_users where email='" . $pvs['email'] . "'")) > 0) {
            return _EMAILREGISTERED;
        } 
        if (sql_num_rows(sql_query("select uname from ${user_prefix}_users where uname='" . mxAddSlashesForSQL($pvs['uname']) . "'")) > 0) {
            return _NICKTAKEN;
        } 
    } 
    if (function_exists('userCheck_option')) {
        $pvs = userCheck_option($pvs);
        if (!empty($pvs['userCheckError'])) {
            return $pvs['userCheckError'];
        } 
    } 
    return $pvs;
} 
// ################################################
function vkpUserIsThisTheUser($uid)
{
    global $user_prefix;
    if (!MX_IS_USER) return 0;
    static $lastuid, $status;
    if ($lastuid != $uid) {
        $cookie = mxGetUserSession();
        $uname = $cookie[1];
        $pass = $cookie[2];
        $qry = "select uid, pass from ${user_prefix}_users where uname='" . mxAddSlashesForSQL($uname) . "'";
        $result = sql_query($qry);
        list($vuid, $vpass) = sql_fetch_row($result);
        $status = (($uid == $vuid) AND ($pass == $vpass));
        $lastuid = $uid;
    } 
    return $status;
} 
// ################################################
function vkpGetBdayString($pvs)
{
    if (!is_array($pvs)) {
        $bday = explode("-", $pvs);
        $pvs = array();
        $pvs['bday_year'] = $bday[0];
        $pvs['bday_month'] = $bday[1];
        $pvs['bday_day'] = $bday[2];
    } 
    $isdate = checkdate((int)$pvs['bday_month'], (int)$pvs['bday_day'], (int)$pvs['bday_year']);
    $bday = ($isdate) ? sprintf("%04d-%02d-%02d 00:00:00", $pvs['bday_year'], $pvs['bday_month'], $pvs['bday_day']) : "";
    $bday = ($isdate) ? formatTimestamp($bday) : "";
    return $bday;
} 
// ################################################
function makePass()
{
    $out = "";
    $shuffles = "er,in,tia,wol,fe,pre,vet,jo,nes,al,len,son,cha,ir,ler,bo,ok,tio,nar,sim,ple,bla,ten,toe,cho,co,lat,spe,ak,er,po,co,lor,pen,cil,li,ght,wh,at,the,he,ck,is,mam,bo,no,fi,ve,any,way,pol,iti,cs,ra,dio,sou,rce,sea,rch,pa,per,com,bo,sp,eak,st,fi,rst,gr,oup,boy,ea,gle,tr,ail,bi,ble,brb,pri,dee,kay,en,be,se";
    $arrshuffle = explode(",", $shuffles);
    srand((double)microtime() * 1000000);
    shuffle($arrshuffle);
    for ($count = 1;$count <= 4;$count++) {
        if (rand() % 10 == 1) {
            $out .= sprintf("%0.0f", (rand() % 50) + 1);
        } else {
            $out .= sprintf("%s", $arrshuffle[rand() % 62]);
        } 
    } 
    if (strlen($out) < $GLOBALS['minpass']) {
        $out = str_pad($out, $GLOBALS['minpass'], strrev($out), STR_PAD_BOTH);
    } 
    if (function_exists("str_shuffle")) {
        $out = str_shuffle($out);
    } 
    return($out);
} 
// ################################################
function vkpYaGetAvatars()
{
    $handle = @opendir(MX_PATH_AVATAR);
    if ($handle) {
        while ($file = readdir($handle)) {
            if (ereg(".gif|.jpg|.jpeg", $file)) {
                $filelist[] = $file;
            } 
        } 
        asort($filelist);
    } else {
        $filelist[] = "";
        $filelist[] = "Error: can't open folder '" . MX_PATH_AVATAR . "'";
    } 
    return $filelist;
} 
// ################################################
function vkpUserform($pvs)
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $uname;

    $pvs['uname'] = (empty($pvs['uname'])) ? "" : $pvs['uname'];
    $pvs['user_bday'] = (empty($pvs['user_bday'])) ? "0000-00-00" : $pvs['user_bday']; 
    // $cuser_viewemail  = ($pvs["user_viewemail"]) ? "checked" : "";
    if (function_exists("vkpUserform_option")) {
        $out = vkpUserform_option($pvs);
    } else {
        $cnewsletter = (empty($pvs['newsletter'])) ? "" : "checked";
        $cbday = vkpBdaySelect($pvs['user_bday']);

        if (@file_exists(MX_PATH_AVATAR)) {
            $js = "\n<SCRIPT type=\"text/javascript\">\n"
             . "<!--\n"
             . "function showimage() {\n"
             . "if (!document.images){\n"
             . "return;}\n"
             . "document.images.avatar.src='" . MX_HOME_URL . "/" . MX_PATH_AVATAR . "/' + document.Register.user_avatar.options[document.Register.user_avatar.selectedIndex].value\n"
             . "}\n"
             . "//-->\n"
             . "</SCRIPT>\n";
        } else {
            $js = "\n<SCRIPT type=\"text/javascript\">\n<!--\n"
             . "function showimage() {\n"
             . "return;}\n"
             . "//-->\n"
             . "</SCRIPT>\n";
        } 
        $out = "<tr valign=\"top\"><td colspan=\"4\" bgcolor=\"$bgcolor2\"><font class=\"title\"><b>" . _PERSONALINFO . "</b></font>" . $js . "</td></tr>"
         . "<tr valign=\"top\"><td width=\"20%\" bgcolor=\"$bgcolor2\"><b>" . _UREALNAME . ":</b></td><td colspan=\"3\" width=\"80%\" bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"realname\" size=\"50\" maxlength=\"60\" value=\"" . ((isset($pvs['realname'])) ? mxPrepareToDisplay($pvs['realname']) : "") . "\"></td></tr>\n"
         . "<tr valign=\"top\"><td width=\"20%\" bgcolor=\"$bgcolor2\"><b>" . _YA_USEXUS . ":</b></td><td colspan=\"3\" width=\"80%\" bgcolor=\"$bgcolor3\">\n"
         . "" . vkpSexusSelect("user_sexus", (isset($pvs['user_sexus'])) ? $pvs['user_sexus'] : 0) . "</td></tr>\n"
         . "<tr valign=\"top\"><td width=\"20%\" bgcolor=\"$bgcolor2\"><b>" . _YA_UBDAY . ":</b></td><td colspan=\"3\" width=\"80%\" bgcolor=\"$bgcolor3\">\n"
         . "" . $cbday . "</td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _UFAKEMAIL . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"femail\" size=\"50\" maxlength=\"100\" value=\"" . ((isset($pvs['femail'])) ? mxPrepareToDisplay($pvs['femail']) : "") . "\"><br><span class=\"tiny\">" . _EMAILPUBLIC . "</span></td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YOURHOMEPAGE . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"url\" size=\"50\" maxlength=\"255\" value=\"" . ((isset($pvs['url'])) ? mxPrepareToDisplay($pvs['url']) : "http://") . "\"><br><font class=\"tiny\">" . _OPTIONAL3 . "</font></td></tr>\n"
//GG skype
		."<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>"._YSKYPE.":</b></td>"
		."<td  colspan= \"3\" bgcolor=\"$bgcolor3\" >\n"
		."<input type=\"text\" name=\"user_skype\" size=\"50\" maxlength=\"50\" value=\"".((isset($pvs['user_skype'])) ? mxPrepareToDisplay($pvs['user_skype']) : "")."\"></td></tr>\n"
//GG skype ende
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YICQ . ":</b></td><td bgcolor=\"$bgcolor3\" width=\"20%\">\n"
         . "<input type=\"text\" name=\"user_icq\" size=\"20\" maxlength=\"20\" value=\"" . ((isset($pvs['user_icq'])) ? mxPrepareToDisplay($pvs['user_icq']) : "") . "\"></td>\n" . "<td bgcolor=\"$bgcolor2\" width=\"15%\"><b>" . _YAIM . ":</b></td><td bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"user_aim\" size=\"20\" maxlength=\"18\" value=\"" . ((isset($pvs['user_aim'])) ? mxPrepareToDisplay($pvs['user_aim']) : "") . "\"></td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YYIM . ":</b></td><td bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"user_yim\" size=\"20\" maxlength=\"25\" value=\"" . ((isset($pvs['user_yim'])) ? mxPrepareToDisplay($pvs['user_yim']) : "") . "\"></td>\n" . "<td bgcolor=\"$bgcolor2\"><b>" . _YMSNM . ":</b></td><td bgcolor=\"$bgcolor3\">"
         . "<input type=\"text\" name=\"user_msnm\" size=\"20\" maxlength=\"25\" value=\"" . ((isset($pvs['user_msnm'])) ? mxPrepareToDisplay($pvs['user_msnm']) : "") . "\"></td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YLOCATION . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"user_from\" size=\"60\" maxlength=\"100\" value=\"" . ((isset($pvs['user_from'])) ? mxPrepareToDisplay($pvs['user_from']) : "") . "\"></td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YOCCUPATION . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"user_occ\" size=\"60\" maxlength=\"100\" value=\"" . ((isset($pvs['user_occ'])) ? mxPrepareToDisplay($pvs['user_occ']) : "") . "\"></td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YINTERESTS . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">\n"
         . "<input type=\"text\" name=\"user_intrest\" size=\"60\" maxlength=\"150\" value=\"" . ((isset($pvs['user_intrest'])) ? mxPrepareToDisplay($pvs['user_intrest']) : "") . "\"></td></tr>\n"
         . "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _EXTRAINFO . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">"
         . "<textarea name=\"bio\" rows=\"5\" cols=\"57\">" . ((isset($pvs['bio'])) ? htmlspecialchars($pvs['bio'], ENT_QUOTES) : "") . "</textarea><br><span class=\"tiny\">" . _CANKNOWABOUT . "</span></td></tr>\n"; 
        // Nur anzeigen wenn aktiviert und keine Neuregistrierung!
        if (mxModuleAllowed("Avatar") && MX_IS_USER) {
            // Avatar Upload...
            $isAvatar = mxIsAvatarUploaded($pvs['uname'], false, true);
            if (empty($isAvatar['werist'])) {
                $filelist = vkpYaGetAvatars();
                $curava = (empty($pvs['user_avatar'])) ? "blank.gif" : $pvs['user_avatar'];
                foreach($filelist as $value) {
                    $sel = ($curava == $value) ? "selected" : "";
                    $xavatar[] = "<option value=\"$value\" $sel>$value\n";
                } 
                $avOptions = implode("", $xavatar);
                unset($xavatar);
                $out .= "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YOURAVATAR . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">";
                $out .= "<table width=\"20%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr valign=\"top\">\n";
                $out .= "<td><select name=\"user_avatar\" onChange=\"showimage()\">" . $avOptions . "</select></td>";
                $out .= "<td>&nbsp;&nbsp;<img src=\"" . MX_PATH_AVATAR . "/" . $curava . "\" id=\"avatar\" name=\"avatar\" width=\"32\" height=\"32\" alt=\"\">&nbsp;&nbsp;</td>";
                $out .= "<td nowrap>&nbsp;&nbsp;[ <a href=\"modules.php?name=Your_Account&amp;op=avatarlist\" target=\"_blank\">" . _LIST . "</a> ]</td>";
                $out .= "</tr></table></td></tr>\n";
            } else {
                $out .= "<tr><td bgcolor=\"$bgcolor2\"><b>" . _UPLOADETAVATAR . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">";
                $out .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n";
                $out .= "<td>" . mxCreateImage(MX_PATH_MEMBERAVATAR . "/" . $isAvatar['werist']) . "</td><td nowrap>&nbsp;&nbsp;<a href=\"modules.php?name=Avatar&amp;file=deletAvatar&amp;username=" . $pvs['uname'] . "&fileName=" . $isAvatar['werist'] . "&amp;id=" . $isAvatar['id'] . "\">" . _DELETEAVATAR . "</a>" . "</td>";
                $out .= "</tr></table></td></tr>\n";
            } 
        } else {
            $filelist = vkpYaGetAvatars();
            $curava = (empty($pvs['user_avatar'])) ? "blank.gif" : $pvs['user_avatar'];
            foreach($filelist as $value) {
                $sel = ($curava == $value) ? "selected" : "";
                $xavatar[] = "<option value=\"$value\" $sel>$value\n";
            } 
            $avOptions = implode("", $xavatar);
            unset($xavatar);
            $out .= "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _YOURAVATAR . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\"><table width=\"20%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr valign=\"top\"><td nowrap>\n";
            $out .= "<select name=\"user_avatar\" onChange=\"showimage()\">" . $avOptions . "</select>&nbsp;&nbsp;[ <a href=\"modules.php?name=Your_Account&amp;op=avatarlist\" target=\"_blank\">" . _LIST . "</a> ]" . "</td><td>&nbsp;&nbsp;&nbsp;&nbsp;<img src=\"" . MX_PATH_AVATAR . "/" . $curava . "\" id=\"avatar\" name=\"avatar\" width=\"32\" height=\"32\" alt=\"\"></td></tr></table>" . "</td></tr>\n";
        } 
        $out .= "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _SIGNATURE . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\">\n";
        $out .= "<TEXTAREA NAME=\"user_sig\" ROWS=\"6\" COLS=\"57\">" . ((isset($pvs['user_sig'])) ? htmlspecialchars($pvs['user_sig'], ENT_QUOTES) : "") . "</TEXTAREA></td></tr>\n";
        $out .= "<tr valign=\"top\"><td bgcolor=\"$bgcolor2\"><b>" . _NEWSLETTER . ":</b></td><td colspan=\"3\" bgcolor=\"$bgcolor3\"><INPUT TYPE=\"CHECKBOX\" NAME=\"newsletter\" VALUE=\"1\" " . $cnewsletter . "> " . _RECEIVENEWSLETTER . "</td></tr>\n";
    } 
    return $out;
} 
// ######################################################################
function vkpBdaySelect($bday)
{
    if (empty($bday)) {
        $year = 0;
        $month = 0;
        $day = 0;
    } else {
        $bday = explode("-", $bday);
        $year = (int)$bday[0];
        $month = (int)$bday[1];
        $day = (int)$bday[2];
        $isdate = checkdate($month, $day, $year);
        if (!$isdate) {
            $year = 0;
            $month = 0;
            $day = 0;
        } 
    } 
    $year = (empty($year)) ? "" : $year;
    $xday = 1;
    $sel = (empty($day)) ? "selected" : "";
    $d[] = "<option value=\"0\" " . $sel . ">-</option>";
    while ($xday <= 31) {
        $sel = ($xday == (int)$day) ? "selected" : "";
        $d[] = "<option value=\"" . $xday . "\" " . $sel . ">" . $xday . "</option>";
        $xday++;
    } 
    $xmonth = 1;
    $sel = (empty($month)) ? "selected" : "";
    $m[] = "<option value=\"0\" " . $sel . ">-</option>";
    while ($xmonth <= 12) {
        $sel = ($xmonth == (int)$month) ? "selected" : "";
        $m[] = "<option value=\"" . $xmonth . "\" " . $sel . ">" . $xmonth . "</option>";
        $xmonth++;
    } 
    $out = " " . _YA_BDAY . ": <select name=\"bday_day\">" . (implode("\n", $d)) . "</select>";
    $out .= " " . _YA_BMONTH . ": <select name=\"bday_month\">" . (implode("\n", $m)) . "</select>";
    $out .= " " . _YA_BYEAR . ": <input type=\"text\" name=\"bday_year\" value=\"" . $year . "\" size=\"5\" maxlength=\"4\">";
    return $out;
} 
// ####################################################################
function vkpSexusSelect($fieldname, $sexus = 0, $hidenull = 0)
{
    $sexus = (empty($sexus)) ? 0 : (int)$sexus;
    $out = "<select name='" . $fieldname . "' size='1'>\n";
    if (!$hidenull) {
        $out .= "<option value='0'" . (($sexus == 0) ? " selected" : "") . ">" . _YA_NOSEX . "</option>\n";
    } 
    $out .= "<option value='1'" . (($sexus == 1) ? " selected" : "") . ">" . _YA_FEMALE . "</option>\n";
    $out .= "<option value='2'" . (($sexus == 2) ? " selected" : "") . ">" . _YA_MALE . "</option>\n";
    $out .= "</select>\n";
    return $out;
} 
// ################################################
function vkpGetSexusString($sexus = 0)
{
    $sexus = (empty($sexus)) ? 0 : (int)$sexus;
    switch ($sexus) {
    case 0: $out = _YA_NOSEX;
        break;
    case 1: $out = _YA_FEMALE . " " . mxCreateImage("images/f.gif", _YA_FEMALE);
        break;
    case 2: $out = _YA_MALE . " " . mxCreateImage("images/m.gif", _YA_MALE);
        break;
    } 
    return $out;
} 
// ################################################
function vkpYaIsUblockActive()
{
    global $prefix;
    $result = sql_query("select active from " . $prefix . "_blocks where bkey='userbox'");
    list($ubactive) = sql_fetch_row($result);
    return $ubactive;
} 
// ################################################
function vkpYaGetOptionLangfile()
{
    $lang = $GLOBALS["currentlang"];
    $langpath = "modules/Your_Account/language";
    $ok = @include_once($langpath . "/option-" . $lang . ".php");
    if ($ok) return $lang; 
    // deutsch_du noch beachten und ggf. includen
    if (ereg('german', $lang)) {
        $xlang = ($lang == 'german') ? 'german_du' : 'german';
        $ok = @include_once($langpath . "/option-" . $xlang . ".php");
        if ($ok) return $xlang;
    } 
} 
// ################################################
function mxCheckUserTempTable()
{
    global $prefix, $user_prefix;

    $result = sql_query("SHOW COLUMNS FROM `${user_prefix}_users`");
    while ($row = sql_fetch_assoc($result)) {
        $user_fields[$row['Field']] = $row;
    } 
    ksort($user_fields);
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query("SHOW COLUMNS FROM `${user_prefix}_users_temptable`");
    while ($row = sql_fetch_assoc($result)) {
        $temp_fields[$row['Field']] = $row;
    } 
    unset($temp_fields['check_key'], $temp_fields['ncheck_time'], $temp_fields['check_ip'], $temp_fields['check_host'], $temp_fields['check_thepss'], $temp_fields['check_isactive']);
    ksort($temp_fields); 
    // wenn die beiden Arrays gleich sind, die Funktion beenden
    if ($temp_fields == $user_fields) {
        return true;
    } 
    // alle Felder der alten Temp-Table auslesen
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query("SHOW COLUMNS FROM `${user_prefix}_users_temptable`");
    while (list($fieldname) = sql_fetch_row($result)) {
        // nur wenn bereits das entsprechende Feld auch in der neuen Tabelle existiert..
        if (isset($new_fields[$fieldname])) {
            $old_fields[$fieldname] = $fieldname;
        } 
    } 
    // eindeutiger Name fr temporre Tabelle
    $temptable = uniqid('temp_tbl_'); 
    // die zustzlichen Felder fr die temporre Tabelle
    $createfields = "ALTER TABLE `$temptable` 
	ADD `check_key` int(5) NOT NULL default 0,
	ADD `check_time` int(11) NOT NULL default 0,
	ADD `check_ip` varchar(16) NOT NULL default '',
	ADD `check_host` varchar(60) NOT NULL default '',
	ADD `check_thepss` varchar(40) NOT NULL default '',
	ADD `check_isactive` tinyint(1) NOT NULL default 0
	"; 
    // Struktur der Usertabelle auslesen
    list($tname, $tcreate) = sql_fetch_row(sql_query("SHOW CREATE TABLE `{$user_prefix}_users`;")); 
    // Die Struktur bearbeiten, Tabellennamen ersetzen
    $tcreate = preg_replace('#(CREATE\sTABLE\s`?)(' . $tname . ')(`?\s)#i', '$1' . $temptable . '$3', $tcreate); 
    // falls temporre Tabelle existiert, diese lschen
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query("DROP TABLE IF EXISTS `$temptable`;"); 
    // neue temporre Tabelle erstellen
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query($tcreate); 
    // die zustzlichen Felder in der neuen temporre Tabelle erstellen
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query($createfields); 
    // prfen, ob Neuanmeldungen in der alten temporren Tabelle vorhanden sind
    list($newcount) = sql_fetch_row(sql_query("SELECT COUNT(uid) FROM `{$user_prefix}_users_temptable`")); 
    // wenn ja, diese in die neue Tabelle importieren
    if ($newcount) {
        // alle Felder der neuen Temp-Table auslesen
        $qry = "SHOW COLUMNS FROM `${temptable}`;";
        $GLOBALS['mxSkipSqlDetect'] = true;
        $result = sql_query($qry);
        while (list($fieldname) = sql_fetch_row($result)) {
            $new_fields[$fieldname] = $fieldname;
        } 
        // alle Felder der alten Temp-Table auslesen
        $qry = "SHOW COLUMNS FROM `${user_prefix}_users_temptable`;";
        $GLOBALS['mxSkipSqlDetect'] = true;
        $result = sql_query($qry);
        while (list($fieldname) = sql_fetch_row($result)) {
            // nur wenn bereits das entsprechende Feld auch in der neuen Tabelle existiert..
            if (isset($new_fields[$fieldname])) {
                $old_fields[$fieldname] = $fieldname;
            } 
        } 
        // die Arrays noch umgekehrt abgleichen und daraus neues Array erstellen,
        // welches nur Feldnamen enthlt, die in beiden Tabellen vorkommen
        foreach ($new_fields as $fieldname) {
            // nur wenn bereits das entsprechende Feld auch in der alten Tabelle existiert..
            if (isset($old_fields[$fieldname])) {
                $change_fields[$fieldname] = $fieldname;
            } 
        } 

        if (isset($change_fields)) {
            $change_fields = '`' . implode('`,`', $change_fields) . '`'; 
            // die Insertanweisung zusammensetzen
            $qry = "INSERT INTO `$temptable` (" . $change_fields . ") SELECT " . $change_fields . " FROM `${user_prefix}_users_temptable`;"; 
            // Insertanweisung ausfhren
            $GLOBALS['mxSkipSqlDetect'] = true;
            sql_query($qry);
        } 
    } 
    // die alte temporre Tabelle lschen
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query("DROP TABLE IF EXISTS `${user_prefix}_users_temptable`;"); 
    // die neue Tabelle umbenennen zum Namen der alten...
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query("ALTER TABLE `$temptable` RENAME `${user_prefix}_users_temptable` ;"); 
    // Aufrumen falls temporre Tabelle existiert, diese lschen
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query("DROP TABLE IF EXISTS `$temptable`;");
} 

?>
