<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2005 pragmaMx Dev Team - http://pragmaMx.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Source: /home/cvs/pragmamx/stable/modules/Members_List/index.php,v $
 * $Revision: 1.4 $
 * $Author: tora60 $
 * $Date: 2005/10/23 21:33:09 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

/**
 */
/* Based on MyPHPortal Modified MembersList                             */
/* Some code taken from MemberList coded by Paul Joseph Thompson        */
/* of www.slug.okstate.edu                                              */
/* In memoriam of Members List War ;)                                   */
/*                                                                      */
/**
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");
$GLOBALS["index"] = 1;
$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);

$letter = 'A'; /// Standardauswahl
$sortby = "uname"; /// Standardsortierung
$pagesize = 20; /// Anzahl der Zeilen in der Liste

define('MX_ML_IMAGEPATH', 'modules/' . $module_name . '/images/');
define('MX_ML_IMAGEPATH2', 'images/');

define('IMG_MAIL', mxCreateImage(MX_ML_IMAGEPATH . 'email.png', 'Send Email'));
define('IMG_WWW', mxCreateImage(MX_ML_IMAGEPATH . 'www.png', 'Visit Homepage'));
define('IMG_ICQ', mxCreateImage(MX_ML_IMAGEPATH . 'icq.png', 'Add to List'));
define('IMG_AIM', mxCreateImage(MX_ML_IMAGEPATH . 'aim.png', 'Send Message'));
define('IMG_YIM', mxCreateImage(MX_ML_IMAGEPATH . 'yim.png', 'Send Message'));
define('IMG_MSN', mxCreateImage(MX_ML_IMAGEPATH . 'msn.png', 'Get Screen Name'));
define('IMG_PMS', mxCreateImage(MX_ML_IMAGEPATH . 'pm.gif', 'Private Message'));

define('IMG_EDIT' , mxCreateImage(MX_ML_IMAGEPATH . 'edit.png', _EDIT));
define('IMG_DELE', mxCreateImage(MX_ML_IMAGEPATH . 'delete.png', _DELETE));

$memlist_pmallowed = mxModuleAllowed('Private_Messages');
# ########################################################################################
// / sql-injectfix by AE, betr. u.a.: http://www.gulftech.org/01032004.php
$memlistletters = array (_MEMALL, 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', _MEMOTHER);
if (isset($_GET['letter'])) {
    $letter = (in_array($_GET['letter'], $memlistletters)) ? $_GET['letter'] : $letter;
}
if (isset($_GET['sortby'])) {
    $memlistsortbys = array('uname', 'name', 'femail', 'url');
    $sortby = (in_array($_GET['sortby'], $memlistsortbys)) ? $_GET['sortby'] : $sortby;
    unset($memlistsortbys);
}
$page = (isset($_GET['page'])) ? (int)$_GET['page'] : 1;
# ########################################################################################
function alpha()
{
    /* Creates the list of letters and makes them a link. */
    global $sortby, $module_name, $memlistletters, $letter;
    $num = count($memlistletters) - 1;
    echo "<center>[ ";
    /* start of HTML */
    $counter = 0;
    foreach ($memlistletters as $ltr) {
        $ltr_v = $ltr;
        if ($ltr == $letter) {
            $ltr_v = '<b>' . $ltr . '</b>';
        }
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=" . $ltr . "&amp;sortby=" . $sortby . "\">" . $ltr_v . "</a>";
        if ($counter == round($num / 2)) {
            echo " ]\n<br>\n[ ";
        } else if ($counter != $num) {
            echo "&nbsp;|&nbsp;\n";
        }
        $counter++;
    }
    echo " ]\n</center>\n<br>\n"; // end of HTML
}
# ########################################################################################
function SortLinks($letter) // Makes order by links..
{
    global $sortby, $module_name;
    echo "\n<center>\n"; // Start of HTML
    echo "" . _SORTBY . " [ ";
    if ($sortby == "uname" OR !$sortby) {
        echo "" . _MNICKNAME . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=uname\">" . _MNICKNAME . "</a>&nbsp;|&nbsp;";
    }
    if ($sortby == "name") {
        echo "" . _MREALNAME . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=name\">" . _MREALNAME . "</a>&nbsp;|&nbsp;";
    }
    if ($sortby == "femail") {
        echo "" . _MEMAIL . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=femail\">" . _MEMAIL . "</a>&nbsp;|&nbsp;";
    }
    if ($sortby == "url") {
        echo "" . _MURL . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=url\">" . _MURL . "</a>";
    }
    echo " ]\n</center>\n"; // end of HTML
}
# ########################################################################################
$pagetitle = _MEMBERSLIST;
include("header.php");
/* This is the header section that displays the last registered and who's logged in and whatnot */
$result = sql_query("select uname from ${user_prefix}_users WHERE user_stat=1 order by uid DESC limit 0,1");
list($lastuser) = sql_fetch_row($result);
echo "\n\n<!-- MEMBERS LIST -->\n\n";
OpenTable();
echo "<center><b>" . _WELCOMETO . " " . $GLOBALS["sitename"] . " " . _MEMBERSLIST . "</b><br><br>\n";
echo "" . _GREETINGS . " <a href=\"modules.php?name=Userinfo&amp;uname=$lastuser\">$lastuser</a>\n</center>\n<br>\n";
list($numrows) = sql_fetch_row(sql_query("select count(uid) from ${user_prefix}_users WHERE user_stat=1"));

if (MX_IS_USER || MX_IS_ADMIN) {
    $member_online_num = 0;
    $past = time() - MX_SETINACTIVE_MINS ;
    $result2 = sql_query("SELECT uname FROM ${user_prefix}_users
												WHERE ((user_lastvisit >= " . $past . ") AND (user_stat=1) AND (user_lastmod<>'logout'))
												ORDER BY uname"); #(uname Not In (".$excludedusers.")) AND
    while (list($username) = sql_fetch_row($result2)) {
        $list[] = "<a href=\"modules.php?name=Userinfo&amp;uname=" . $username . "\">" . $username . "</a>\n";
        $member_online_num++;
    }
    $who_online = (isset($list)) ? implode(" - ", $list) : "";
    echo "<center>" . _WEHAVE . " <b>" . $numrows . "</b> " . _MREGISTERED . " <b>" . $member_online_num . "</b>\n " . _MREGONLINE . "</center><br>";
    if ($member_online_num) {
        OpenTable2();
        echo "<center><b>" . _ONLINEREG . " </b><br><br>" . $who_online . "</center>\n";
        CloseTable2();
        echo "<br>";
    }
} else {
    echo "<center>" . _WEHAVE . " <b>$numrows</b> " . _REGSOFAR . "</center>\n<br>\n<br>\n";
}

alpha();
SortLinks($letter);

/* end of top memberlist section thingie */
/* This starts the beef...*/

$min = $pagesize * ($page - 1); // This is where we start our record set from
$max = $pagesize; // This is how many rows to select

/* All my SQL stuff. DO NOT ALTER ANYTHING UNLESS YOU KNOW WHAT YOU ARE DOING */

/* This is a totaly crap code, any help to re-code this functions will be very appreciated */
/* Need to be database independent */

$count = "SELECT COUNT(uid) AS total FROM ${user_prefix}_users "; // Count all the users in the db..
$select = "select uid, name, uname, femail, url, user_msnm, user_yim, user_aim, user_icq, user_skype from ${user_prefix}_users "; //select our data
$where = "where uname <> 'Anonymous' AND user_stat=1 ";
if (($letter != _MEMOTHER) AND ($letter != _MEMALL)) { // are we listing all or "other" ?
    $where .= "AND uname like '" . $letter . "%' "; // I guess we are not..
} else if (($letter == _MEMOTHER) AND ($letter != _MEMALL)) { // But other is numbers ?
    $where .= "AND uname REGEXP \"^\[1-9]\" "; // REGEX :D, although i think its MySQL only
    // Will have to change this later.
    // if you know a better way to match only the first char
    // to be a number in uname, please change it and email
    // myphportal-developers@lists.sourceforge.net the correction
    // or goto http://sourceforge.net/projects/myphportal and post
    // your correction there. Thanks, Bjorn.
} else { // or we are unknown or all..
    $where .= ""; // this is to get rid of anoying "undefinied variable" message
}
$sort = "order by $sortby"; //sorty by .....
$limit = " ASC LIMIT " . $min . ", " . $max; // we only want rows $min  to $max
/* due to how this works, i need the total number of users per
letter group, then we can hack of the ones we want to view */
$count_result = sql_query($count . $where);
list($num_rows_per_order) = sql_fetch_row($count_result);

/* This is where we get our limit'd result set. */
$result = sql_query($select . $where . $sort . $limit); # or die(); // Now lets do it !!

/* Crap code ends here */

echo "<br>";

echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\"><tr>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">" . _NICKNAME . "</font></th>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">" . _REALNAME . "</font></th>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">" . _EMAIL . "</font></th>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">" . _URL . "</font></th>\n";
echo "<th BGCOLOR=\"$bgcolor4\" align=\"center\"><font color=\"$textcolor2\"><u><b>Skype</b></u></font></th>\n";//GG
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">ICQ</font></th>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">AIM</font></th>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">YIM</font></th>\n";
echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">MSNM</font></th>\n";
$cols = 8;
if ($memlist_pmallowed) {
    $cols++;
    echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">PM</font></th>\n";
}
if (MX_IS_ADMIN) {
    $cols++;
    echo "<th bgcolor=\"$bgcolor4\"><font color=\"$textcolor2\">" . _FUNCTIONS . "</font></th>\n";
}
echo "</tr>";
$a = 0;
$dcolor_A = $bgcolor2;
$dcolor_B = $bgcolor1;

$num_users = sql_num_rows($result); //number of users per sorted and limit query
if ($num_rows_per_order > 0) {
    while ($theuser = sql_fetch_array($result)) {
        $dcolor = ($a == 0 ? $dcolor_A : $dcolor_B);
        echo "<tr><td bgcolor=\"$dcolor\"><font color=\"$textcolor1\"><a href=\"modules.php?name=Userinfo&amp;uname=" . $theuser["uname"] . "\">" . $theuser["uname"] . "</a></font>&nbsp;</td>\n";
        echo "<td bgcolor=\"$dcolor\"><font color=\"$textcolor1\">&nbsp;&nbsp;&nbsp;&nbsp;$theuser[name]</font>&nbsp;</td>\n";
        echo "<td bgcolor='$dcolor'>";

        if ($theuser["femail"]) {
            echo "<a class=\"img\" href=\"mailto:" . mxPrepareToDisplay($theuser["femail"]) . "\" target=\"new\">" . IMG_MAIL . "</a>";
        }
        echo "</td><td bgcolor='$dcolor'>";

        if ($theuser["url"]) {
            echo "
			<a href=\"" . $theuser["url"] . "\" target=\"new\">" . IMG_WWW . "</a>			";
        }
//GG skype
	 echo "</td><td bgcolor='$dcolor'>";
		if ($theuser["user_skype"]) {
		echo "<a class=\"img\" href=\"CALLTO://$theuser[user_skype]\" target=\"_blank\">"
			."<img class=\"img\" src=\"images/skype.gif\" border=\"0\" alt=\"Add to List\"></a>"
			."";
			}
	echo "</td>\n";
//GG skype ende

        echo "</td><td bgcolor='$dcolor'>";

        if (is_numeric($theuser["user_icq"])) {
            echo "
			<a href=\"http://wwp.icq.com/$theuser[user_icq]#pager\" target=\"_blank\">
			<img src=\"http://wwp.icq.com/scripts/online.dll?icq=" . $theuser['user_icq'] . "&img=5\" border=\"0\" alt=\"Online Status/Pager\"></a>
			<a href=\"http://wwp.icq.com/scripts/search.dll?to=$theuser[user_icq]\">" . IMG_ICQ . "</a>
			";
        }

        echo "</td>\n";
        echo "<td bgcolor='$dcolor'>";

        if ($theuser["user_aim"]) {
            echo "<a href=\"aim:goim?screenname=$theuser[user_aim]&message=Hi+$theuser[user_aim].+Are+you+there?\">" . IMG_AIM . "</a>";
        }
        echo "</td>\n";

        echo "<td bgcolor='$dcolor'>";
        if ($theuser["user_yim"]) {
            echo "<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=$theuser[user_yim]&.src=pg\">" . IMG_YIM . "</a>";
        }
        echo "</td>";

        echo "<td bgcolor='$dcolor'>";
        if ($theuser["user_msnm"]) {
            echo "<a href=\"modules.php?name=Userinfo&amp;uname=" . $theuser["uname"] . "\">" . IMG_MSN . "</a>";
        }
        echo "</td>";

        if ($memlist_pmallowed) {
            echo "
			<td bgcolor='$dcolor'>
			<a href=\"modules.php?name=Private_Messages&amp;op=send_to&amp;to_user=" . $theuser["uname"] . "\">" . IMG_PMS . "</a></td>
			";
        }

        if (MX_IS_ADMIN) {
            echo "
			<td bgcolor=\"$dcolor\" align=\"center\">
			<a href=\"admin.php?chng_uid=$theuser[uid]&amp;op=modifyUser\">" . IMG_EDIT . "</a>&nbsp;
			<a href=\"admin.php?op=delUser&amp;chng_uid=$theuser[uid]\">" . IMG_DELE . "</a>
			</td>";
        }

        echo "</tr>";
        $a = ($dcolor == $dcolor_A ? 1 : 0);
    }
    // start of next/prev/row links.
    echo "\n<tr><td colspan='$cols' align='right'>\n";
    echo "<br><br>";
    OpenTable();
    echo "\t<table width='100%' cellspacing='0' cellpadding='0' border=0><tr>";

    if ($num_rows_per_order > $pagesize) {
        $total_pages = ceil($num_rows_per_order / $pagesize); // How many pages are we dealing with here ??
        $prev_page = $page - 1;

        if ($prev_page > 0) {
            echo "<td align='left' width='15%'><a href='modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$prev_page'>";
            echo mxCreateImage(MX_ML_IMAGEPATH . 'left.gif', _PREVIOUS . " (" . $prev_page . ")");
            echo "</a></td>";
        } else {
            echo "<td width='15%'>&nbsp;</td>\n";
        }

        echo "<td align='center' width='70%'>";
        echo "<font class=tiny>$num_rows_per_order " . _USERSFOUND . " <b>$letter</b> ($total_pages " . _PAGES . ", $num_users " . _USERSSHOWN . ")</font>";
        echo "</td>";

        $next_page = $page + 1;
        if ($next_page <= $total_pages) {
            echo "<td align='right' width='15%'><a href='modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$next_page'>";
            echo mxCreateImage(MX_ML_IMAGEPATH . 'right.gif', _NEXTPAGE . " (" . $next_page . ")");
            echo "</a></td>";
        } else {
            echo "<td width='15%'>&nbsp;</td></tr>\n";
        }
        /* Added a numbered page list, only shows up to 50 pages. */

        echo "<tr><td colspan=\"3\" align=\"center\">";
        echo " <font class=tiny>[ </font>";

        for($n = 1; $n < $total_pages; $n++) {
            if ($n == $page) {
                echo "<font class=tiny><b>$n</b></font></a>";
            } else {
                echo "<a href='modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$n'>";
                echo "<font class=tiny>$n</font></a>";
            }
            if ($n >= 50) { // if more than 50 pages are required, break it at 50.
                $break = true;
                break;
            } else { // guess not.
                echo "<font class=tiny> | </font>";
            }
        }

        if (!isset($break)) { // are we sopposed to break ?
            if ($n == $page) {
                echo "<font class=tiny><b>$n</b></font></a>";
            } else {
                echo "<a href='modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$total_pages'>";
                echo "<font class=tiny>$n</font></a>";
            }
        }
        echo " <font class=tiny>]</font> ";
        echo "</td></tr>";

        /* This is where it ends */
    } else { // or we dont have any users..
        echo "<td align='center'>";
        echo "<font class=tiny>$num_rows_per_order " . _USERSFOUND . " $letter</font>";
        echo "</td></tr>";
    }

    echo "</table>\n";
    CloseTable();
    echo "</td></tr>\n";
    // end of next/prev/row links
} else { // you have no members on this letter, hahaha
    echo "<tr><td bgcolor=\"$dcolor_A\" colspan=\"$cols\" align=\"center\"><br>\n";
    echo "<b><font color=\"$textcolor1\">" . _NOMEMBERS . " $letter</font></b>\n";
    echo "<br></td></tr>\n";
}

echo "\n</table><br>\n";

CloseTable();
include("footer.php");

?>